diff --git a/src/backend/storage/ipc/shmem.c b/src/backend/storage/ipc/shmem.c
index a3d56cf55dd..fbc05f0dc13 100644
--- a/src/backend/storage/ipc/shmem.c
+++ b/src/backend/storage/ipc/shmem.c
@@ -19,11 +19,11 @@
  * methods).  The routines in this file are used for allocating and
  * binding to shared memory data structures.
  *
- * This module provides facilities to allocate fixed-size structures in shared
- * memory, for things like variables shared between all backend processes.
- * Each such structure has a string name to identify it, specified when it is
- * requested.  shmem_hash.c provides a shared hash table implementation on top
- * of that.
+ * This module provides facilities to allocate fixed-size as well as resizable
+ * structures in shared memory, for things like variables shared between all
+ * backend processes. Each such structure has a string name to identify it,
+ * specified when it is requested.  shmem_hash.c provides a shared hash table
+ * implementation on top of fixed-size structures.
  *
  * Shared memory areas should usually not be allocated after postmaster
  * startup, although we do allow small allocations later for the benefit of
@@ -102,6 +102,23 @@
  * (*options->ptr), and calls the attach_fn callback, if any, for additional
  * per-backend setup.
  *
+ * Resizable shared memory structures
+ * ----------------------------------
+ *
+ * In order to allocate resizable shared memory structures, set
+ * ShmemRequestStructOpts::maximum_size to the maximum size that the structure
+ * can grow to.  The address space for the maximum size will be reserved at
+ * startup, but memory is allocated or freed as the structure grows or shrinks
+ * respectively. ShmemRequestStructOpts::size should be set to the initial size
+ * of the structure, which is the amount of memory allocated at the startup.
+ * Optionally, ShmemRequestStructOpts::minimum_size can be set to the minimum
+ * size that the structure can shrink to. After startup, the structure can be
+ * resized by calling ShmemResizeStruct(). ShmemResizeStruct() enforces that the
+ * new size is within [minimum_size, maximum_size].
+ *
+ * While resizable structures can be created after the startup, the memory
+ * available for them is quite limited.
+ *
  * Legacy ShmemInitStruct()/ShmemInitHash() functions
  * --------------------------------------------------
  *
@@ -268,6 +285,10 @@ typedef struct
 	void	   *location;		/* location in shared mem */
 	Size		size;			/* # bytes requested for the structure */
 	Size		allocated_size; /* # bytes actually allocated */
+	Size		minimum_size;	/* the minimum size the structure can shrink
+								 * to */
+	Size		maximum_size;	/* the maximum size the structure can grow to */
+	Size		reserved_space; /* the total address space reserved */
 } ShmemIndexEnt;
 
 /* To get reliable results for NUMA inquiry we need to "touch pages" once */
@@ -276,6 +297,8 @@ static bool firstNumaTouch = true;
 static void CallShmemCallbacksAfterStartup(const ShmemCallbacks *callbacks);
 static void InitShmemIndexEntry(ShmemRequest *request);
 static bool AttachShmemIndexEntry(ShmemRequest *request, bool missing_ok);
+static Size EstimateAllocatedSize(ShmemIndexEnt *entry);
+static void ShmemProtectStructInternal(ShmemIndexEnt *entry);
 
 Datum		pg_numa_available(PG_FUNCTION_ARGS);
 
@@ -341,25 +364,63 @@ ShmemRequestInternal(ShmemStructOpts *options, ShmemRequestKind kind)
 	if (options->name == NULL)
 		elog(ERROR, "shared memory request is missing 'name' option");
 
+#ifndef HAVE_RESIZABLE_SHMEM
+	if (options->maximum_size > 0)
+		elog(ERROR, "resizable shared memory is not supported on this platform");
+	if (options->minimum_size > 0)
+		elog(ERROR, "resizable shared memory is not supported on this platform");
+#else
+	if (options->maximum_size > 0 && shared_memory_type != SHMEM_TYPE_MMAP)
+		elog(ERROR, "resizable shared memory requires shared_memory_type = mmap");
+#endif
+
 	if (IsUnderPostmaster)
 	{
 		if (options->size <= 0 && options->size != SHMEM_ATTACH_UNKNOWN_SIZE)
 			elog(ERROR, "invalid size %zd for shared memory request for \"%s\"",
 				 options->size, options->name);
+		if (options->minimum_size < 0 && options->minimum_size != SHMEM_ATTACH_UNKNOWN_SIZE)
+			elog(ERROR, "invalid minimum_size %zd for shared memory request for \"%s\"",
+				 options->minimum_size, options->name);
+		if (options->maximum_size < 0 && options->maximum_size != SHMEM_ATTACH_UNKNOWN_SIZE)
+			elog(ERROR, "invalid maximum_size %zd for shared memory request for \"%s\"",
+				 options->maximum_size, options->name);
 	}
 	else
 	{
-		if (options->size == SHMEM_ATTACH_UNKNOWN_SIZE)
+		if (options->size == SHMEM_ATTACH_UNKNOWN_SIZE ||
+			options->minimum_size == SHMEM_ATTACH_UNKNOWN_SIZE ||
+			options->maximum_size == SHMEM_ATTACH_UNKNOWN_SIZE)
 			elog(ERROR, "SHMEM_ATTACH_UNKNOWN_SIZE cannot be used during startup");
 		if (options->size <= 0)
 			elog(ERROR, "invalid size %zd for shared memory request for \"%s\"",
 				 options->size, options->name);
+		if (options->minimum_size < 0)
+			elog(ERROR, "invalid minimum_size %zd for shared memory request for \"%s\"",
+				 options->minimum_size, options->name);
+		if (options->maximum_size < 0)
+			elog(ERROR, "invalid maximum_size %zd for shared memory request for \"%s\"",
+				 options->maximum_size, options->name);
 	}
 
 	if (options->alignment != 0 && pg_nextpower2_size_t(options->alignment) != options->alignment)
 		elog(ERROR, "invalid alignment %zu for shared memory request for \"%s\"",
 			 options->alignment, options->name);
 
+	if (options->minimum_size > 0 && options->size != SHMEM_ATTACH_UNKNOWN_SIZE &&
+		options->minimum_size > options->size)
+		elog(ERROR, "resizable shared memory structure \"%s\" should have minimum size (%zd) less than or equal to size (%zd)",
+			 options->name, options->minimum_size, options->size);
+
+	if (options->maximum_size > 0 && options->size > options->maximum_size)
+		elog(ERROR, "resizable shared memory structure \"%s\" should have maximum size (%zd) greater than size (%zd)",
+			 options->name, options->maximum_size, options->size);
+
+	if (options->minimum_size > 0 && options->maximum_size > 0 &&
+		options->minimum_size > options->maximum_size)
+		elog(ERROR, "resizable shared memory structure \"%s\" should have minimum size (%zd) less than or equal to maximum size (%zd)",
+			 options->name, options->minimum_size, options->maximum_size);
+
 	/* Check that we're in the right state */
 	if (shmem_request_state != SRS_REQUESTING)
 		elog(ERROR, "ShmemRequestStruct can only be called from a shmem_request callback");
@@ -381,36 +442,70 @@ ShmemRequestInternal(ShmemStructOpts *options, ShmemRequestKind kind)
 }
 
 /*
- *	ShmemGetRequestedSize() --- estimate the total size of all registered shared
- *                              memory structures.
+ * ShmemGetRequestedSize() --- estimate total size of all registered shared
+ * memory structures.
+ *
+ * Returns three totals:
+ * - initial - the sum of initial sizes of the requested structures which is the
+ * total amount of memory required at the startup.
+ * - min - the total of minimum sizes of structures
+ * - max - the sum of maximum sizes of the structures, which is the address
+ * space that must be reserved.
+ *
+ * When there are no resizable structures or on the platforms that do not
+ * support resizable structures, all three totals are the same.
  *
  * This is called at postmaster startup, before the shared memory segment has
  * been created.
  */
-size_t
-ShmemGetRequestedSize(void)
+void
+ShmemGetRequestedSize(size_t *initial, size_t *min, size_t *max)
 {
-	size_t		size;
+	size_t		initial_size;
+	size_t		min_size;
+	size_t		max_size;
 
 	/* memory needed for the ShmemIndex */
-	size = hash_estimate_size(list_length(pending_shmem_requests) + SHMEM_INDEX_ADDITIONAL_SIZE,
-							  sizeof(ShmemIndexEnt));
-	size = CACHELINEALIGN(size);
+	initial_size = hash_estimate_size(list_length(pending_shmem_requests) + SHMEM_INDEX_ADDITIONAL_SIZE,
+									  sizeof(ShmemIndexEnt));
+	initial_size = CACHELINEALIGN(initial_size);
+	min_size = initial_size;
+	max_size = initial_size;
 
 	/* memory needed for all the requested areas */
 	foreach_ptr(ShmemRequest, request, pending_shmem_requests)
 	{
 		size_t		alignment = request->options->alignment;
+		size_t		req_min;
+		size_t		req_max;
+		size_t		req_initial = request->options->size;
+
+		if (request->options->maximum_size > 0)
+		{
+			req_min = request->options->minimum_size;
+			req_max = request->options->maximum_size;
+		}
+		else
+		{
+			req_min = req_initial;
+			req_max = req_initial;
+		}
 
 		/* pad the start address for alignment like ShmemAllocRaw() does */
 		if (alignment < PG_CACHE_LINE_SIZE)
 			alignment = PG_CACHE_LINE_SIZE;
-		size = TYPEALIGN(alignment, size);
+		initial_size = TYPEALIGN(alignment, initial_size);
+		min_size = TYPEALIGN(alignment, min_size);
+		max_size = TYPEALIGN(alignment, max_size);
 
-		size = add_size(size, request->options->size);
+		initial_size = add_size(initial_size, req_initial);
+		min_size = add_size(min_size, req_min);
+		max_size = add_size(max_size, req_max);
 	}
 
-	return size;
+	*initial = initial_size;
+	*min = min_size;
+	*max = max_size;
 }
 
 /*
@@ -431,6 +526,23 @@ ShmemInitRequested(void)
 	 * Initialize the ShmemIndex entries and perform basic initialization of
 	 * all the requested memory areas.  There are no concurrent processes yet,
 	 * so no need for locking.
+	 *
+	 * TODO: If we have resizable structures, we will mmap with MAP_NORESERVE.
+	 * In case there is not enough memory to cover the initial sizes of the
+	 * shared structures, the mmap will succeed but the initialization will
+	 * fail with SIGBUS. Instead we should allocate the memory worth the
+	 * initial size of each structure using madvise(MADV_WRITE_POPOULATE). But
+	 * instead of doing that for each structure, we should combine contiguous
+	 * structures and do it once for the whole range. The algorithm to use is
+	 * as follows 1. start from the first request 2. note the start address of
+	 * the first structure in the range 3. walk upto a resizable structure or
+	 * the last request, noting the initial end address of the last structure
+	 * in the range 4. call madvise(MADV_WRITE_POPULATE) for the range (start
+	 * address, end address) 5. Next structure becomes the first structure in
+	 * the next range, repeat from step 2
+	 *
+	 * If there are no resizable structure, no need to do anything, as all the
+	 * memory is reserved during mmap itself.
 	 */
 	foreach_ptr(ShmemRequest, request, pending_shmem_requests)
 	{
@@ -514,6 +626,7 @@ InitShmemIndexEntry(ShmemRequest *request)
 	ShmemIndexEnt *index_entry;
 	bool		found;
 	size_t		allocated_size;
+	size_t		requested_size;
 	void	   *structPtr;
 
 	/* look it up in the shmem index */
@@ -531,10 +644,19 @@ InitShmemIndexEntry(ShmemRequest *request)
 	}
 
 	/*
-	 * We inserted the entry to the shared memory index.  Allocate requested
-	 * amount of shared memory for it, and initialize the index entry.
+	 * We inserted the entry to the shared memory index. Allocate requested
+	 * amount of address space in the shared memory segment for it, and do
+	 * basic initializion. The memory gets allocated during initialization as
+	 * the corresponding memory pages are written to.  Allocate enough space
+	 * for a resizable structure to grow to its maximum size. It is expected
+	 * that the initialization callback will use only as much memory as the
+	 * initial size of the resizable structure. (Well, if it doesn't, more
+	 * memory will be allocated initially than expected, no further harm is
+	 * done.)
 	 */
-	structPtr = ShmemAllocRaw(request->options->size,
+	requested_size = request->options->maximum_size > 0 ?
+		request->options->maximum_size : request->options->size;
+	structPtr = ShmemAllocRaw(requested_size,
 							  request->options->alignment,
 							  &allocated_size);
 	if (structPtr == NULL)
@@ -543,13 +665,36 @@ InitShmemIndexEntry(ShmemRequest *request)
 		hash_search(ShmemIndex, name, HASH_REMOVE, NULL);
 		ereport(ERROR,
 				(errcode(ERRCODE_OUT_OF_MEMORY),
-				 errmsg("not enough shared memory for data structure"
+				 errmsg("not enough shared memory space for data structure"
 						" \"%s\" (%zd bytes requested)",
-						name, request->options->size)));
+						name, requested_size)));
 	}
 	index_entry->size = request->options->size;
 	index_entry->allocated_size = allocated_size;
 	index_entry->location = structPtr;
+	index_entry->reserved_space = allocated_size;
+	if (request->options->maximum_size > 0)
+	{
+		index_entry->minimum_size = request->options->minimum_size;
+		index_entry->maximum_size = request->options->maximum_size;
+
+		/* Adjust allocated size of a resizable structure. */
+		index_entry->allocated_size = EstimateAllocatedSize(index_entry);
+
+		/*
+		 * Protect the unused part of the reserved address space for a
+		 * resizable structure. If the structure has same minimum and maximum
+		 * size, it is effectively a fixed-size structure without any unused
+		 * space; no protection is required.
+		 */
+		if (index_entry->minimum_size != index_entry->maximum_size)
+			ShmemProtectStructInternal(index_entry);
+	}
+	else
+	{
+		index_entry->minimum_size = request->options->size;
+		index_entry->maximum_size = request->options->size;
+	}
 
 	/* Initialize depending on the kind of shmem area it is */
 	switch (request->kind)
@@ -594,7 +739,7 @@ AttachShmemIndexEntry(ShmemRequest *request, bool missing_ok)
 		return false;
 	}
 
-	/* Check that the size in the index matches the request */
+	/* Check that the sizes in the index match the request. */
 	if (index_entry->size != request->options->size &&
 		request->options->size != SHMEM_ATTACH_UNKNOWN_SIZE)
 	{
@@ -604,6 +749,43 @@ AttachShmemIndexEntry(ShmemRequest *request, bool missing_ok)
 						name, index_entry->size, request->options->size)));
 	}
 
+	/*
+	 * For resizable structures, also check that minimum_size and maximum_size
+	 * match. For fixed-size structures, these are derived (set to size) in
+	 * the index entry and not meaningful in the request.
+	 */
+	if (request->options->maximum_size != 0)
+	{
+		if (index_entry->minimum_size != request->options->minimum_size &&
+			request->options->minimum_size != SHMEM_ATTACH_UNKNOWN_SIZE)
+		{
+			ereport(ERROR,
+					errmsg("shared memory struct \"%s\" was created with"
+						   " different minimum_size: existing %zu, requested %zu",
+						   name, index_entry->minimum_size,
+						   request->options->minimum_size));
+		}
+
+		if (index_entry->maximum_size != request->options->maximum_size &&
+			request->options->maximum_size != SHMEM_ATTACH_UNKNOWN_SIZE)
+		{
+			ereport(ERROR,
+					errmsg("shared memory struct \"%s\" was created with"
+						   " different maximum_size: existing %zu, requested %zu",
+						   name, index_entry->maximum_size,
+						   request->options->maximum_size));
+		}
+	}
+	else
+	{
+		if (index_entry->minimum_size != index_entry->maximum_size)
+			elog(ERROR, "shared memory struct \"%s\" was created as resizable, but requested as fixed-size",
+				 name);
+	}
+
+	if (index_entry->minimum_size != index_entry->maximum_size)
+		ShmemProtectStructInternal(index_entry);
+
 	/*
 	 * Re-establish the caller's pointer variable, or do other actions to
 	 * attach depending on the kind of shmem area it is.
@@ -625,6 +807,291 @@ AttachShmemIndexEntry(ShmemRequest *request, bool missing_ok)
 	return true;
 }
 
+/*
+ * Estimate the actual memory allocated for a resizable structure.
+ *
+ * ... based on the assumption that the memory is allocated in pages.
+ *
+ * The memory pages covered by the current size of a resizable structure are
+ * considered to be allocated. The memory page where the maximal structure ends
+ * also hosts the next structure, unless the maximal structure ends on a page
+ * boundary. Hence that page is allocated because of the next structure. The
+ * memory pages between the page where the current structure ends and the page
+ * where the next structure starts remain unallocated. Thus the memory allocated
+ * for a resizable structure can be estimated as the total address space
+ * reserved for the structure minus the unallocated memory pages between the
+ * current end and the next structure.
+ */
+static Size
+EstimateAllocatedSize(ShmemIndexEnt *entry)
+{
+	Size		page_size = GetOSPageSize();
+	char	   *align_end = (char *) TYPEALIGN(page_size, (char *) entry->location + entry->size);
+	char	   *floor_max_end = (char *) TYPEALIGN_DOWN(page_size, (char *) entry->location + entry->maximum_size);
+
+	Assert(entry->maximum_size >= entry->size);
+	Assert(entry->reserved_space >= entry->maximum_size);
+
+	if (align_end < floor_max_end)
+		return entry->reserved_space - (floor_max_end - align_end);
+
+	return entry->reserved_space;
+}
+
+/*
+ * ShmemResizeStruct() --- resize a resizable shared memory structure.
+ *
+ * The new size must be within [minimum_size, maximum_size].  If the structure
+ * is being shrunk, the memory pages that are no longer needed are freed. If
+ * the structure is being expanded, the memory pages that are needed for the
+ * new size are allocated. See EstimateAllocatedSize() for explanation of which
+ * pages are allocated for a resizable structure.
+ *
+ * The caller must ensure that no other backend is accessing the part of the
+ * structure between the old size and the new size while this function is
+ * running. It should also ensure that all backends that may access the
+ * structure have observed the new size before they access the range between
+ * the old size and the new size.
+ *
+ * If we can not allocate memory pages when expanding the structure, this
+ * function will return false. On success it returns true. Instead
+ * of returning false, an error is raised if we can not free the memory pages
+ * when shrinking the structure, which should not happen in practice.
+ */
+bool
+ShmemResizeStruct(const char *name, Size new_size)
+{
+#ifndef HAVE_RESIZABLE_SHMEM
+	ereport(ERROR,
+			errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+			errmsg("resizable shared memory is not supported on this platform"));
+	pg_unreachable();
+#else
+	ShmemIndexEnt *result;
+	bool		found;
+	Size		page_size = GetOSPageSize();
+	char	   *new_end;
+	bool		success = true;
+
+	Assert(new_size > 0);
+
+	/*
+	 * Resizable shared memory structures are only supported with mmap'ed
+	 * memory.
+	 */
+	Assert(shared_memory_type == SHMEM_TYPE_MMAP);
+
+	/* look it up in the shmem index */
+	LWLockAcquire(ShmemIndexLock, LW_EXCLUSIVE);
+	result = (ShmemIndexEnt *) hash_search(ShmemIndex, name, HASH_FIND, &found);
+	if (!found)
+		ereport(ERROR,
+				errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				errmsg("shmem struct \"%s\" is not initialized", name));
+
+	Assert(result);
+
+	if (result->minimum_size == result->maximum_size)
+		ereport(ERROR,
+				errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				errmsg("shared memory struct \"%s\" is not resizable", name));
+
+	if (new_size < result->minimum_size)
+		ereport(ERROR,
+				errcode(ERRCODE_INSUFFICIENT_RESOURCES),
+				errmsg("cannot shrink shared memory structure \"%s\" below minimum size"
+					   "(requested %zu bytes, minimum %zu bytes)",
+					   name, new_size, result->minimum_size));
+
+	if (result->maximum_size < new_size)
+		ereport(ERROR,
+				errcode(ERRCODE_INSUFFICIENT_RESOURCES),
+				errmsg("not enough address space is reserved for resizing structure \"%s\""
+					   " (required %zu bytes, reserved %zu bytes)",
+					   name, new_size, result->maximum_size));
+
+	/*
+	 * A structure requires memory pages from the page containing the start of
+	 * the structure and current end of the structure to be allocated. When
+	 * expanding, we make sure that pages are allocated up to the new end.
+	 * When shrinking, release memory pages beyond the new end, but not the
+	 * page containing maximal end of the structure, as it may be used by the
+	 * next structure.
+	 *
+	 * We do not consider the current end of the structure as it simplifies
+	 * the calculations. Instead we rely on the underlying APIs not to touch
+	 * the memory pages that will not be affected by the change in size.
+	 */
+	new_end = (char *) TYPEALIGN(page_size, (char *) result->location + new_size);
+	if (new_size < result->size)
+	{
+		char	   *max_end = (char *) TYPEALIGN_DOWN(page_size, (char *) result->location + result->maximum_size);
+
+		if (max_end > new_end)
+		{
+			if (!PGSharedMemoryEnsureFreed(new_end, max_end - new_end))
+				ereport(ERROR,
+						errcode(ERRCODE_SYSTEM_ERROR),
+						errmsg("could not free %zu bytes of shared memory from structure \"%s\"",
+							   result->size - new_size, name));
+		}
+	}
+	else if (new_size > result->size)
+	{
+		char	   *struct_start = (char *) TYPEALIGN_DOWN(page_size, (char *) result->location);
+
+		if (new_end > struct_start)
+		{
+			ShmemIndexEnt entry_copy = *result;
+
+			/*
+			 * Allocating memory pages in the expanded range may require the
+			 * corresponding address space to have read-write access.
+			 */
+			entry_copy.size = new_size;
+			ShmemProtectStructInternal(&entry_copy);
+
+			if (!PGSharedMemoryEnsureAllocated(struct_start, new_end - struct_start))
+			{
+				ShmemProtectStructInternal(result);
+				ereport(WARNING,
+						errcode(ERRCODE_OUT_OF_MEMORY),
+						errmsg("could not allocate %zu bytes of shared memory to structure \"%s\"",
+							   new_size - result->size, name));
+				success = false;
+			}
+		}
+	}
+
+	/* Update shmem index entry. */
+	if (success)
+	{
+		result->size = new_size;
+		result->allocated_size = EstimateAllocatedSize(result);
+	}
+
+	LWLockRelease(ShmemIndexLock);
+
+	return success;
+#endif
+}
+
+/*
+ * ShmemProtectStruct() --- protect the unused portion of the given resizable
+ * structure.
+ *
+ * Makes the region beyond the current size up to maximum_size inaccessible, and
+ * ensures the region up to the current size is readable and writable. Depending
+ * upon the platform, the protection honours the page boundaries. So it may be
+ * more permissible than strictly needed.
+ *
+ * This function only affects the calling backend's address space. After each
+ * ShmemResizeStruct(), every backend that may access the structure should call
+ * this function before its next access. When backends are still in the middle
+ * of that round of ShmemProtectStruct() calls, ShmemResizeStruct() should not
+ * be called.
+ */
+void
+ShmemProtectStruct(const char *name)
+{
+#ifndef HAVE_RESIZABLE_SHMEM
+	ereport(ERROR,
+			errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+			errmsg("resizable shared memory is not supported on this platform"));
+#else
+	ShmemIndexEnt *result;
+	bool		found;
+
+	LWLockAcquire(ShmemIndexLock, LW_SHARED);
+
+	result = (ShmemIndexEnt *) hash_search(ShmemIndex, name, HASH_FIND, &found);
+	if (!found)
+		ereport(ERROR,
+				errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				errmsg("shmem struct \"%s\" is not initialized", name));
+
+	if (result->minimum_size == result->maximum_size)
+		ereport(ERROR,
+				errcode(ERRCODE_OBJECT_NOT_IN_PREREQUISITE_STATE),
+				errmsg("shared memory struct \"%s\" is not resizable", name));
+
+	ShmemProtectStructInternal(result);
+
+	LWLockRelease(ShmemIndexLock);
+#endif
+}
+
+/*
+ * ShmemProtectStructInternal --- same as ShmemProtectStruct()
+ *
+ * ..., but called when the ShmemIndexEnt of the struct is available. The caller
+ * should hold ShmemIndexLock if required.
+ */
+static void
+ShmemProtectStructInternal(ShmemIndexEnt *entry)
+{
+#ifndef HAVE_RESIZABLE_SHMEM
+	ereport(ERROR,
+			errcode(ERRCODE_FEATURE_NOT_SUPPORTED),
+			errmsg("resizable shared memory is not supported on this platform"));
+#else
+	Size		page_size = GetOSPageSize();
+	char	   *rw_start;
+	char	   *rw_end;
+	char	   *prot_end;
+
+	Assert(shared_memory_type == SHMEM_TYPE_MMAP);
+	Assert(entry->minimum_size != entry->maximum_size);
+
+	/* Make at least [location, location+size) readable and writable */
+	rw_start = (char *) TYPEALIGN_DOWN(page_size, entry->location);
+	rw_end = (char *) TYPEALIGN(page_size,
+								(char *) entry->location + entry->size);
+
+	/*
+	 * Make remaining portion inaccessible while making sure that the portion
+	 * after maximum_size is not affected since it may be used by other
+	 * structures.
+	 */
+	prot_end = (char *) TYPEALIGN_DOWN(page_size,
+									   (char *) entry->location + entry->maximum_size);
+
+	if (!PGSharedMemoryProtect(rw_start, rw_end, prot_end))
+		ereport(ERROR,
+				errcode(ERRCODE_SYSTEM_ERROR),
+				errmsg("could not protect shared memory structure \"%s\"", entry->key));
+#endif
+}
+
+/*
+ * ShmemReprotectResizableStructs() --- re-apply per-backend protection to every
+ * resizable shmem structure.
+ *
+ * On !EXEC_BACKEND platforms, a new backend inherits shmem mappings and their
+ * per-process protections from the postmaster. If any resizable structure has
+ * been resized since postmaster start, the inherited protections no longer
+ * match the current size. This is called early in per-backend startup so the
+ * new backend sees the protections according to the current sizes of the
+ * resizable structures.
+ */
+void
+ShmemReprotectResizableStructs(void)
+{
+#ifdef HAVE_RESIZABLE_SHMEM
+	HASH_SEQ_STATUS status;
+	ShmemIndexEnt *entry;
+
+	LWLockAcquire(ShmemIndexLock, LW_SHARED);
+	hash_seq_init(&status, ShmemIndex);
+	while ((entry = (ShmemIndexEnt *) hash_seq_search(&status)) != NULL)
+	{
+		if (entry->minimum_size != entry->maximum_size)
+			ShmemProtectStructInternal(entry);
+	}
+	LWLockRelease(ShmemIndexLock);
+#endif
+}
+
 /*
  *	InitShmemAllocator() --- set up basic pointers to shared memory.
  *
@@ -731,6 +1198,9 @@ InitShmemAllocator(PGShmemHeader *seghdr)
 		Assert(!found);
 		result->size = ShmemAllocator->index_size;
 		result->allocated_size = ShmemAllocator->index_size;
+		result->minimum_size = result->size;
+		result->maximum_size = result->size;
+		result->reserved_space = result->allocated_size;
 		result->location = ShmemAllocator->index;
 	}
 }
@@ -1047,7 +1517,7 @@ ShmemInitStruct(const char *name, Size size, bool *foundPtr)
 Datum
 pg_get_shmem_allocations(PG_FUNCTION_ARGS)
 {
-#define PG_GET_SHMEM_SIZES_COLS 4
+#define PG_GET_SHMEM_SIZES_COLS 7
 	ReturnSetInfo *rsinfo = (ReturnSetInfo *) fcinfo->resultinfo;
 	HASH_SEQ_STATUS hstat;
 	ShmemIndexEnt *ent;
@@ -1069,7 +1539,20 @@ pg_get_shmem_allocations(PG_FUNCTION_ARGS)
 		values[1] = Int64GetDatum((char *) ent->location - (char *) ShmemSegHdr);
 		values[2] = Int64GetDatum(ent->size);
 		values[3] = Int64GetDatum(ent->allocated_size);
-		named_allocated += ent->allocated_size;
+		values[4] = Int64GetDatum(ent->minimum_size);
+		values[5] = Int64GetDatum(ent->maximum_size);
+		values[6] = Int64GetDatum(ent->reserved_space);
+
+		/*
+		 * Anonymous areas are allocated in the area remaining after all named
+		 * areas have been allocated. Thus the amount of shared memory
+		 * allocated for anonymous areas can be calculated as the total amount
+		 * of space allocated minus the amount of space allocated for named
+		 * areas. The amount of free shared memory at the end of the segment
+		 * can be calculated as the total size of the segment minus the total
+		 * amount of space allocated.
+		 */
+		named_allocated += ent->reserved_space;
 
 		tuplestore_putvalues(rsinfo->setResult, rsinfo->setDesc,
 							 values, nulls);
@@ -1080,6 +1563,9 @@ pg_get_shmem_allocations(PG_FUNCTION_ARGS)
 	nulls[1] = true;
 	values[2] = Int64GetDatum(ShmemAllocator->free_offset - named_allocated);
 	values[3] = values[2];
+	values[4] = values[2];
+	values[5] = values[2];
+	values[6] = values[2];
 	tuplestore_putvalues(rsinfo->setResult, rsinfo->setDesc, values, nulls);
 
 	/* output as-of-yet unused shared memory */
@@ -1088,6 +1574,9 @@ pg_get_shmem_allocations(PG_FUNCTION_ARGS)
 	nulls[1] = false;
 	values[2] = Int64GetDatum(ShmemSegHdr->totalsize - ShmemAllocator->free_offset);
 	values[3] = values[2];
+	values[4] = values[2];
+	values[5] = values[2];
+	values[6] = values[2];
 	tuplestore_putvalues(rsinfo->setResult, rsinfo->setDesc, values, nulls);
 
 	LWLockRelease(ShmemIndexLock);
@@ -1274,23 +1763,9 @@ pg_get_shmem_allocations_numa(PG_FUNCTION_ARGS)
 Size
 pg_get_shmem_pagesize(void)
 {
-	Size		os_page_size;
-#ifdef WIN32
-	SYSTEM_INFO sysinfo;
-
-	GetSystemInfo(&sysinfo);
-	os_page_size = sysinfo.dwPageSize;
-#else
-	os_page_size = sysconf(_SC_PAGESIZE);
-#endif
-
 	Assert(IsUnderPostmaster);
-	Assert(huge_pages_status != HUGE_PAGES_UNKNOWN);
-
-	if (huge_pages_status == HUGE_PAGES_ON)
-		GetHugePageSize(&os_page_size, NULL);
 
-	return os_page_size;
+	return GetOSPageSize();
 }
 
 Datum
diff --git a/src/backend/storage/lmgr/proc.c b/src/backend/storage/lmgr/proc.c
index 9d6e69175a5..780cdb5e9ff 100644
--- a/src/backend/storage/lmgr/proc.c
+++ b/src/backend/storage/lmgr/proc.c
@@ -575,6 +575,14 @@ InitProcess(void)
 	if (IsUnderPostmaster)
 		AttachSharedMemoryStructs();
 #endif
+
+	/*
+	 * Update access to the address space occupied by the resizable shared
+	 * structures. We do it here so that the structures can be accessed safely
+	 * by this backend. But we will do this again after ProcSignalInit() for
+	 * the reasons mentioned there.
+	 */
+	ShmemReprotectResizableStructs();
 }
 
 /*
@@ -756,6 +764,14 @@ InitAuxiliaryProcess(void)
 	if (IsUnderPostmaster)
 		AttachSharedMemoryStructs();
 #endif
+
+	/*
+	 * Update access to the address space occupied by the resizable shared
+	 * structures. We do it here so that the structures can be accessed safely
+	 * by this backend. But we will do this again after ProcSignalInit() for
+	 * the reasons mentioned there.
+	 */
+	ShmemReprotectResizableStructs();
 }
 
 /*
diff --git a/src/backend/utils/init/postinit.c b/src/backend/utils/init/postinit.c
index 3d8c9bdebd5..815b865aa38 100644
--- a/src/backend/utils/init/postinit.c
+++ b/src/backend/utils/init/postinit.c
@@ -787,6 +787,16 @@ InitPostgres(const char *in_dbname, Oid dboid,
 	 */
 	InitLocalDataChecksumState();
 
+	/*
+	 * Refresh per-backend protections for resizable shmem structures. Usually
+	 * the subsystems using resizable shared structures will use
+	 * ProcSignalBarrier mechanism to coordinate resizing which would involve
+	 * adjusting the protections as well. Like InitLocalDataChecksumState()
+	 * above, this must run after ProcSignalInit so as not to miss a barrier
+	 * for protection change.
+	 */
+	ShmemReprotectResizableStructs();
+
 	RESUME_INTERRUPTS();
 
 	/*
diff --git a/src/backend/utils/misc/guc_tables.c b/src/backend/utils/misc/guc_tables.c
index 1ec460b6a82..17d50ffde38 100644
--- a/src/backend/utils/misc/guc_tables.c
+++ b/src/backend/utils/misc/guc_tables.c
@@ -643,8 +643,12 @@ static int	max_index_keys;
 static int	max_identifier_length;
 static int	block_size;
 static int	segment_size;
-static int	shared_memory_size_mb;
-static int	shared_memory_size_in_huge_pages;
+static int	shared_memory_initial_size_mb;
+static int	shared_memory_minimum_size_mb;
+static int	shared_memory_maximum_size_mb;
+static int	shared_memory_initial_size_in_huge_pages;
+static int	shared_memory_minimum_size_in_huge_pages;
+static int	shared_memory_maximum_size_in_huge_pages;
 static int	wal_block_size;
 static int	num_os_semaphores;
 static int	effective_wal_level = WAL_LEVEL_REPLICA;
@@ -664,6 +668,13 @@ static bool assert_enabled = DEFAULT_ASSERT_ENABLED;
 #endif
 static bool exec_backend_enabled = EXEC_BACKEND_ENABLED;
 
+#ifdef HAVE_RESIZABLE_SHMEM
+#define HAVE_RESIZABLE_SHMEM_ENABLED true
+#else
+#define HAVE_RESIZABLE_SHMEM_ENABLED false
+#endif
+static bool have_resizable_shmem_enabled = HAVE_RESIZABLE_SHMEM_ENABLED;
+
 static char *recovery_target_timeline_string;
 static char *recovery_target_string;
 static char *recovery_target_xid_string;
